# This is the SPEC file for creating binary and source RPMs for the VMs.
#
#
# The Qubes OS Project, http://www.qubes-os.org
#
# Copyright (C) 2010  Joanna Rutkowska <joanna@invisiblethingslab.com>
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; either version 2
# of the License, or (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
Name:		qubes-gui-agent-selinux
Version:	4.2.11
Release:	1%{?dist}
Summary:	The Qubes GUI Agent for AppVMs
License:	GPLv2+
URL:		https://www.qubes-os.org
BuildArch: noarch

BuildRequires: selinux-policy
BuildRequires: selinux-policy-devel
BuildRequires: qubes-core-agent-selinux
Requires(post): qubes-core-agent-selinux
BuildRequires: qubes-core-qrexec-vm-selinux
Requires(post): qubes-core-qrexec-vm-selinux
%{?selinux_requires}

Source0: qubes-gui-agent-%{version}.tar.gz

%description
SELinux policy for the Qubes GUI Agent.  This allows the Qubes GUI Agent to run
in a VM with SELinux enforcing, as is the default on Red Hat-family
distributions.

%prep
%setup -qn qubes-gui-agent-%{version}

%files
%_datadir/selinux/packages/qubes-gui-agent.pp

%build
%{?set_build_flags}
#make clean
make selinux

%clean
rm -rf $RPM_BUILD_ROOT
rm -f %{name}-%{version}

%install
make install-selinux DESTDIR=$RPM_BUILD_ROOT \
                     LIBDIR=%{_libdir} \
                     DATADIR=%{_datadir} \

%post

%selinux_modules_install %{_datadir}/selinux/packages/qubes-gui-agent.pp

%postun
if [ "$1" -eq 0 ]; then
    %selinux_modules_uninstall %{_datadir}/selinux/packages/qubes-gui-agent.pp
fi || :

%posttrans
%selinux_relabel_post
exit 0

%changelog
* Mon Nov 20 2023 Qubes OS Team <qubes-devel@googlegroups.com>
- For complete changelog see: https://github.com/QubesOS/qubes-gui-agent-linux.git

* Mon Nov 20 2023 Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com> - 12638a4
- version 4.2.11

* Sat Nov 18 2023 Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com> - bd627d2
- rpm: use fillup tool to manage /etc/sysconfig/desktop on openSUSE

* Sat Nov 18 2023 Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com> - f07a2b7
- rpm: put PAM config in /usr/lib/pam.d on openSUSE

* Sat Nov 18 2023 Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com> - 407ebc0
- rpm: drop explicit dependency on libXfixes

* Sat Nov 18 2023 Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com> - be67a2b
- Move lightdm.service drop-in into /usr/lib

* Thu Nov 16 2023 Rusty Bird <rustybird@net-c.com> - 0aae614
- vmside: avoid XGetWindowAttributes() call if result isn't used

* Thu Nov 16 2023 Rusty Bird <rustybird@net-c.com> - 7d8f143
- vmside: disambiguate two identical error messages

* Thu Nov 16 2023 Rusty Bird <rustybird@net-c.com> - ae2d083
- vmside: add newline to error messages where it was missing

* Sun Nov 05 2023 Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com> - 9bc0456
- rpm: adjust directory ownership and add relevant BR to satisfy the check

* Sun Nov 05 2023 Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com> - 047545a
- rpm: install files to /usr/etc when relevant on openSUSE

* Sun Nov 05 2023 Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com> - 2271cd7
- pipewire: skip duplicated cflags

* Sun Nov 05 2023 Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com> - 87573cf
- rpm: adjust dependencies for openSUSE

* Sun Nov 05 2023 Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com> - f8b51b6
- rpm: fix dist macro usage

* Fri Nov 03 2023 Frédéric Pierret (fepitre) <frederic.pierret@qubes-os.org> - ad277ff
- Add dedicated PAM file for Gentoo

* Mon Oct 30 2023 Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com> - a333786
- version 4.2.10

* Sat Oct 28 2023 Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com> - 3476590
- pipewire: adjust buffer parameters

* Wed Oct 25 2023 Demi Marie Obenour <demi@invisiblethingslab.com> - 77aa7b0
- Do not override default clock rate or quantum

* Mon Sep 11 2023 Everett Gally <egally@protonmail.com> - 31c5988
- comment explaining why capslock is excluded from key sending

* Mon Sep 11 2023 Everett Gally <egally@protonmail.com> - 6bfefe9
- remove incorrect comment

* Mon Sep 11 2023 Everett Gally <egally@protonmail.com> - 827bb91
- added check to see if modmap is null and moved XFreeModifierMap out of the if statement checking if the current keycode is capslock.

* Sun Sep 10 2023 Everett Gally <egally@protonmail.com> - becf0e7
- remove debug line I added in while testing and forgot to remove in the last commit

* Sun Sep 10 2023 Everett Gally <egally@protonmail.com> - f256db3
- fixed caps lock. It was missing the line to flip its bit in last known states and needs to be excluded from the key send below

* Sun Sep 10 2023 Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com> - b2ff128
- version 4.2.9

* Sat Sep 09 2023 Everett Gally <egally@protonmail.com> - ace84b3
- an extra unused wait_fds[2] line made it in after the conflict was resolved. Removed that line since the variable is unused and stops the build

* Sat Sep 09 2023 Everett Gally <egally@protonmail.com> - bb5297d
- removed some unneeded whitespace

* Sat Sep 09 2023 Everett Gally <egally@protonmail.com> - 1753606
- exclude all BTN_* keys

* Sat Sep 09 2023 Everett Gally <egally@protonmail.com> - b53b05e
- made send_event static

* Sat Sep 09 2023 Everett Gally <egally@protonmail.com> - d30714d
- changed group="user" to group="qubes" in udev rules file. Added lines to install the file in Makefile, appvm-scripts/lib/udev/rules.d/90-qubes-virtual-input-device.rules, debian/qubes-gui-agent.install, and rpm_spec/gui-agent.spec.in

* Fri Sep 08 2023 Everett Gally <egally@protonmail.com> - 98d2dba
- completely separated original handle_keypress function from the one designed for the virtual input device. When input device creation is requested, modifier sync now happens through the uinput_fd instead of the xserver_fd. All modifiers are working as expected when switching between qubes.

* Fri Sep 08 2023 Everett Gally <egally@protonmail.com> - 295464b
- renamed the flag createdInputDevice to created_input_device to follow the same naming convention as other variables

* Fri Sep 08 2023 Everett Gally <egally@protonmail.com> - d8ce3ab
- rename output_fd to uinput_fd so it's clearer what the fd is

* Fri Sep 08 2023 Everett Gally <egally@protonmail.com> - f1637d2
- removed lines setting bits for EV_REL and the REL_BITS. I'm not going to get that in this PR and will work on it in a future one

* Thu Sep 07 2023 Frédéric Pierret (fepitre) <frederic@invisiblethingslab.com> - 2b14649
- Update for Fedora 39

* Sat Sep 02 2023 fepitre-bot <fepitre-bot@qubes-os.org> - bfd9e49
- Add pulseaudio-16.99.1 headers

* Thu Aug 31 2023 Demi Marie Obenour <demi@invisiblethingslab.com> - 52facec
- qubes-gui-runuser: obtain default user from qubesdb

* Thu Aug 31 2023 Demi Marie Obenour <demi@invisiblethingslab.com> - fde57fa
- Fix unchecked malloc()

* Thu Aug 31 2023 Demi Marie Obenour <demi@invisiblethingslab.com> - 6737a90
- Avoid reserved identifier violation

* Thu Aug 31 2023 Demi Marie Obenour <demi@invisiblethingslab.com> - 802e63a
- fix some clang warnings

* Thu Aug 31 2023 Demi Marie Obenour <demi@invisiblethingslab.com> - 42bf492
- Always see if module-vchan-sink.so must be rebuilt

* Thu Aug 31 2023 Demi Marie Obenour <demi@invisiblethingslab.com> - ef1ead4
- Switch from select(2) to poll(2).

* Sun Aug 27 2023 Everett Gally <egally@protonmail.com> - e6d5e59
- Modifier sync will now happen all the time, regardless of whether virtual input device creation was requested or not.

* Sun Aug 27 2023 Everett Gally <egally@protonmail.com> - c2f6757
- virtual input device disabled by default. Can be enabled by enabling the qvm-service 'gui-agent-virtual-input-device'

* Sun Aug 27 2023 Everett Gally <egally@protonmail.com> - b7ad65a
- udev rules file that sets the group owner of the virtual input device to user so xinit can access the device when it's created

* Sat Aug 26 2023 Everett Gally <egally@protonmail.com> - aabe25e
- remove some uneeded whitespace and comments I added previously

* Sat Aug 26 2023 Everett Gally <egally@protonmail.com> - 1b0a80a
- add some log_level checks on some of the fprintf statements I added

* Sat Aug 26 2023 Everett Gally <egally@protonmail.com> - 15b15f8
- removed a comment from a function that doesn't exist anymore

* Sat Aug 26 2023 Everett Gally <egally@protonmail.com> - 047edb5
- added my actual email in the commit so the signature will be verified correctly

* Sat Aug 26 2023 Everett Gally <egally@protonmail.com> - c3fe516
- switched to storing the output_fd and createdInputDevice flag in the ghandles

* Sat Aug 26 2023 Everett Gally <egally@protonmail.com> - cd18ba3
- create input device. if fails, will fall back to xdriver. Keyboard events are working. Mouse events are not currently. Having trouble with getting the cursor into the right position.

* Mon Aug 14 2023 Demi Marie Obenour <demi@invisiblethingslab.com> - d475a29
- Ban old-style declarations and definitions

